/*
 *  $Id$
 *
 * RTEMS Project (http://www.rtems.org/)
 *
 * Copyright 2008 Chris Johns (chrisj@rtems.org)
 */

/**
 * File-system block driver test program.
 */

#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <fcntl.h>

#include <rtems.h>
#include <rtems/bdbuf.h>
#include <rtems/blkdev.h>
#include <rtems/diskdevs.h>
#include <rtems/error.h>

#include "bdbuf-test.h"

int
bdbuf_footprint (int argc, char* argv[])
{
#if 0
  /* Table of disk devices having the same major number */
  struct disk_device_table {
    rtems_disk_device **minor; /* minor-indexed disk device table */
    int size;            /* Number of entries in the table */
  };
  
  rtems_bdbuf_pool_config* bdbuf_pool_config = &rtems_bdbuf_pool_configuration[0];
  size_t                   bdbuf_usage = 0;
  size_t                   diskdevs_usage = 0;
  
  /* bdbuf_initialize_pool bdbuf.c:694 calloc */
  bdbuf_usage += bdbuf_pool_config->num * sizeof (rtems_bdbuf_buffer);
  /* bdbuf_initialize_pool bdbuf.c:703 malloc */
  bdbuf_usage += bdbuf_pool_config->num * bdbuf_pool_config->size;
  /* bdbuf_initialize_pool bdbuf.c:726 sema create */
  /* rtems_bdbuf_init bdbuf.c:792 calloc */
  bdbuf_usage += rtems_bdbuf_pool_configuration_size * sizeof (rtems_bdbuf_pool);
  /* rtems_bdbuf_init bdbuf.c:818 sema create */
  /* rtems_bdbuf_init bdbuf.c:830 task create */

  /* create_disk_entry diskdevs.c:84 realloc */
  diskdevs_usage += sizeof (struct disk_device_table);
  /* create_disk_entry diskdevs.c:111 realloc */
  diskdevs_usage += sizeof (struct rtems_disk_device*);
  /* create_disk_entry diskdevs.c:124 calloc */
  diskdevs_usage += sizeof (struct rtems_disk_device);
  /* create_disk diskdevs.c:192 malloc */
  diskdevs_usage += 32;
  /* rtems_disk_io_initialize diskdevs.c:565 calloc IGNORE due to diskdevs.c:84 */
  /* rtems_disk_io_initialize diskdevs.c:570 sema create */

  printf ("BD Buf Pool size\t%ld\n", sizeof (rtems_bdbuf_pool));
  printf ("BD Buf size\t\t%ld\n", sizeof (rtems_bdbuf_buffer));
  printf ("Total\t\t%ld\n", bdbuf_usage + diskdevs_usage);
  printf ("BD Buffer\t%ld\n", bdbuf_usage);
  printf ("Disk Devices\t%ld\n", diskdevs_usage);

#endif
  return 0;
}

int
main (int argc, char* argv[])
{
  printf ("\nRTEMS Block Driver Buffer Test, Version " \
          PACKAGE_VERSION "\n\n");

  bdbuf_tester ();

  printf ("\nTester finished. Stopping.\n");
  for (;;);
  
  return 0;
}
